# 
# ------ Lists source files for use by Makefile  ------
#  
ELEMENTS =  \
 $(LIB)(a3d3.o) \
 $(LIB)(a3d3_s.o) \
 $(LIB)(ainterpo3ds.o) \
 $(LIB)(ainterpo3dbig.o) \
 $(LIB)(applycref.o) \
 $(LIB)(beautify.o) \
 $(LIB)(beautify_s.o) \
 $(LIB)(bfactor.o) \
 $(LIB)(boxft_lut.o) \
 $(LIB)(calcfx.o) \
 $(LIB)(calcsinc.o) \
 $(LIB)(card10.o) \
 $(LIB)(cards11and12.o) \
 $(LIB)(cards13and14.o) \
 $(LIB)(cards15to18.o) \
 $(LIB)(card1.o) \
 $(LIB)(card2.o) \
 $(LIB)(card3.o) \
 $(LIB)(card4.o) \
 $(LIB)(card5.o) \
 $(LIB)(card6.o) \
 $(LIB)(card7.o) \
 $(LIB)(cards8and9.o) \
 $(LIB)(ccoef.o) \
 $(LIB)(cc3.o) \
 $(LIB)(cc3m.o) \
 $(LIB)(cc3_c.o) \
 $(LIB)(cc3m_c.o) \
 $(LIB)(ccp.o) \
 $(LIB)(checksym.o) \
 $(LIB)(crop_ft.o) \
 $(LIB)(ctfapply.o) \
 $(LIB)(ctfapply_phase_only.o) \
 $(LIB)(ctf.o) \
 $(LIB)(ctfrefine.o) \
 $(LIB)(combine_arrays.o) \
 $(LIB)(correct3d.o) \
 $(LIB)(correct3d_c.o) \
 $(LIB)(d2mask.o) \
 $(LIB)(d3mask.o) \
 $(LIB)(dump.o) \
 $(LIB)(erc.o) \
 $(LIB)(ewaldex.o) \
 $(LIB)(ewaldin.o) \
 $(LIB)(fd.o) \
 $(LIB)(fsh.o) \
 $(LIB)(fangle.o) \
 $(LIB)(find_fpart.o) \
 $(LIB)(find_rlim.o) \
 $(LIB)(fpart_cc.o) \
 $(LIB)(getsymmat.o) \
 $(LIB)(hextend.o) \
 $(LIB)(iof.o) \
 $(LIB)(limitsymm.o) \
 $(LIB)(magrefine.o) \
 $(LIB)(lmain.o) \
 $(LIB)(maskcos.o) \
 $(LIB)(maskcos2.o) \
 $(LIB)(maskcos_c.o) \
 $(LIB)(maskcos2_c.o) \
 $(LIB)(maskenv.o) \
 $(LIB)(mask3d.o) \
 $(LIB)(mask3d_c.o) \
 $(LIB)(match.o) \
 $(LIB)(matmul.o) \
 $(LIB)(matmul_t.o) \
 $(LIB)(opmaps.o) \
 $(LIB)(opmaps2.o) \
 $(LIB)(opresstathalf.o) \
 $(LIB)(opresstatmaps.o) \
 $(LIB)(pad.o) \
 $(LIB)(pda_fft.o) \
 $(LIB)(pdiff.o) \
 $(LIB)(pextract.o) \
 $(LIB)(pinc.o) \
 $(LIB)(pinsert.o) \
 $(LIB)(pinsert_c.o) \
 $(LIB)(pinsert_nearest.o) \
 $(LIB)(pinsert_trilin.o) \
 $(LIB)(pinsert_nearestb.o) \
 $(LIB)(pinsert_trilinb.o) \
 $(LIB)(pinsert_nearest_se.o) \
 $(LIB)(pinsert_trilin_se.o) \
 $(LIB)(pinsert_nearestb_se.o) \
 $(LIB)(pinsert_trilinb_se.o) \
 $(LIB)(prefine.o) \
 $(LIB)(presb.o) \
 $(LIB)(psearch.o) \
 $(LIB)(pweight.o) \
 $(LIB)(random.o) \
 $(LIB)(rlft3_fftw.o) \
 $(LIB)(rotate2d.o) \
 $(LIB)(rotmat.o) \
 $(LIB)(searchang.o) \
 $(LIB)(sheltest.o) \
 $(LIB)(shift2D.o) \
 $(LIB)(shift.o) \
 $(LIB)(shiftvol.o) \
 $(LIB)(sigma.o) \
 $(LIB)(slen2.o) \
 $(LIB)(stamp.o) \
 $(LIB)(storeshift.o) \
 $(LIB)(trilinmap.o) \
 $(LIB)(va04.o) \
 $(LIB)(variance.o) \
 $(LIB)(volmeasure.o) \
 $(LIB)(window.o)

ifeq ($(LIB),$(PGM)_mpfftw.a)
$(PGM) : $(PGM).o $(LIB) merge_3d
	$(COMP) $(LF) $(PGM).o $(LIB) libfftw3f.a -o ../bin/$(PGM)_mpfftw.exe
	@\rm $(PGM).o
else
$(PGM) : $(PGM).o $(LIB) fheader merge_classes merge_3d calc_occ set_polarity rsample resize
	$(COMP) $(LF) $(PGM).o $(LIB) libfftw3f.a -o ../bin/$(PGM).exe
	@\rm $(PGM).o
endif

resize : resize.o $(LIB)
	$(COMP) $(LF) resize.o $(LIB) libfftw3f.a -o ../bin/resize.exe
	@\rm resize.o

fheader : fheader.o $(LIB)
	$(COMP) $(LF) fheader.o $(LIB) libfftw3f.a -o ../bin/fheader.exe
	@\rm fheader.o

merge_classes : merge_classes.o $(LIB)
	$(COMP) $(LF) merge_classes.o $(LIB) -o ../bin/merge_classes.exe
	@\rm merge_classes.o

merge_3d : merge_3d.o $(LIB)
	$(COMP) $(LF) merge_3d.o $(LIB) libfftw3f.a -o ../bin/merge_3d_fftw.exe
	@\rm merge_3d.o

merge_3d : merge_3d.o $(LIB)
	$(COMP) $(LF) merge_3d.o $(LIB) libfftw3f.a -o ../bin/merge_3d_mpfftw.exe
	@\rm merge_3d.o

calc_occ : calc_occ.o $(LIB)
	$(COMP) $(LF) calc_occ.o -o ../bin/calc_occ.exe
	@\rm calc_occ.o

set_polarity : set_polarity.o $(LIB)
	$(COMP) $(LF) set_polarity.o -o ../bin/set_polarity.exe
	@\rm set_polarity.o

rsample : rsample.o $(LIB)
	$(COMP) $(LF) rsample.o -o ../bin/rsample.exe
	@\rm rsample.o

$(PGM).o  : $(PGM).f
	$(COMP) $(FFLAGS) -o $(PGM).o  $(PGM).f

resize.o  : resize.f
	$(COMP) $(FFLAGS) -o resize.o  resize.f

fheader.o  : fheader.f
	$(COMP) $(FFLAGS) -o fheader.o  fheader.f

merge_classes.o  : merge_classes.f
	$(COMP) $(FFLAGS) -o merge_classes.o  merge_classes.f

merge_3d.o  : merge_3d.f
	$(COMP) $(FFLAGS) -o merge_3d.o  merge_3d.f

calc_occ.o  : calc_occ.f
	$(COMP) $(FFLAGS) -o calc_occ.o  calc_occ.f

set_polarity.o  : set_polarity.f
	$(COMP) $(FFLAGS) -o set_polarity.o  set_polarity.f

rsample.o  : rsample.f
	$(COMP) $(FFLAGS) -o rsample.o  rsample.f
